﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityOSC;

public class QuaverCtrl : MonoBehaviour
{

    public float volume;

    Rigidbody2D rg;

    public float jumpForce = 600;
    public float maxSpeed = 5f;

    float tempTime = 0;

    Dictionary<string, ServerLog> servers = new Dictionary<string, ServerLog>();


    // Start is called before the first frame update
    void Start()
    {
        rg = this.gameObject.GetComponent<Rigidbody2D>();

        Application.runInBackground = true;

        OSCHandler.Instance.Init();
        //OSCHandler.Instance.SendMessageToClient("PD", "/unity/trigger", 1);


    }

    // Update is called once per frame
    void Update()
    {
        volume = Mic.volume;


        //************* Routine for receiving the OSC...
        OSCHandler.Instance.UpdateLogs();
        Dictionary<string, ServerLog> servers = new Dictionary<string, ServerLog>();
        servers = OSCHandler.Instance.Servers;

        // foreach (KeyValuePair<string, ServerLog> item in servers) {
        //     // If we have received at least one packet,
        //     // show the last received from the log in the Debug console
        //     if (item.Value.log.Count > 0) {
        //         int lastPacketIndex = item.Value.packets.Count - 1;

        //         //get address and data packet
        //         countText.text = item.Value.packets [lastPacketIndex].Address.ToString ();
        //         countText.text += item.Value.packets [lastPacketIndex].Data [0].ToString ();

        //     }
        // }

        //send volume to pd patch frequently
            SendVolume();

        //*************

        if (volume > 0.1)
        {
            
            MoveForward();
            if (rg.velocity.x > maxSpeed)
            {
                rg.velocity = new Vector2(maxSpeed, rg.velocity.y);
            } 
        }
        if (volume >0.4)
        {
            if(Time.time - tempTime > 1)
            {
                Jump();
                tempTime = Time.time;
            }
            
        }

    }


    void Jump()
    {
        rg.AddForce(Vector2.up *jumpForce*volume);
        OSCHandler.Instance.SendMessageToClient("PD", "/unity/sfx", 0);//0 for jump
    }


    void MoveForward()
    {
        rg.AddForce(Vector2.right * 10);
    }

    void SendVolume()
    {
        //************* Send the message to the client...
        OSCHandler.Instance.SendMessageToClient("PD", "/unity/volume", volume);
        //*************
    }

}
